Compose Finance
Balances

Get balances

Returns custodial (account) and non-custodial (Safe wallet) balances for your organization. **Custodial balances** are grouped by asset and summed across chains. These represent funds held on your behalf by Compose. **Non-custodial balances** are queried on-chain from your organization's Safe wallet. Each entry includes the chain and token contract address.

GET
/api/v2/balances

Returns custodial (account) and non-custodial (Safe wallet) balances for your organization.

Custodial balances are grouped by asset and summed across chains. These represent funds held on your behalf by Compose.

Non-custodial balances are queried on-chain from your organization's Safe wallet. Each entry includes the chain and token contract address.

Authorization

bearerAuth
AuthorizationBearer <token>

Organization API key obtained from PropelAuth

In: header

Response Body

application/json

application/json

application/json

application/json

curl -X GET 'https://compose.finance/api/v2/balances' \  -H 'Authorization: Bearer YOUR_API_KEY'

{
  "custodial": {
    "balances": [
      {
        "currency": "usdc",
        "balance": "1500.00",
        "availableBalance": "1350.00",
        "lockedBalance": "150.00"
      },
      {
        "currency": "eurc",
        "balance": "500.00",
        "availableBalance": "500.00",
        "lockedBalance": "0"
      }
    ]
  },
  "nonCustodial": {
    "address": "0x1234567890abcdef1234567890abcdef12345678",
    "balances": [
      {
        "currency": "usdc",
        "chain": "base",
        "balance": "1000.50",
        "availableBalance": "950.50",
        "lockedBalance": "50",
        "tokenAddress": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913"
      },
      {
        "currency": "ausdc",
        "chain": "base",
        "balance": "200.00",
        "availableBalance": "200.00",
        "lockedBalance": "0",
        "tokenAddress": "0x4e65fE4DbA92790696d040ac24Aa414708F5c0AB"
      }
    ]
  }
}

{
  "error": "Unauthorized - Invalid or missing API key or session"
}
{
  "error": "Customers feature is not enabled for your organization"
}
{
  "error": "Internal server error"
}